import java.lang.reflect.*;

public class Address {
   // Primary key attribute
   int     addrId;

   // Parent class relation attributes
   String  ownerName;
   int     houseId;

   // one-to-one relationship with location attribute
   GeoLoc  location;

   // other (basic) attributes
   String  streetAddr;
   String  city;
   String  state;
   int     zip;


   // The no-argument constructor, reqd by dbMapper
   public Address() {
   }

   // Other constructors
   public Address (int addrId, String ownerName, int houseId,
                   String streetAddr, String city, String state,
                   int zip, GeoLoc location) {
      this.addrId = addrId;
      this.ownerName = ownerName;
      this.houseId = houseId;
      this.streetAddr = streetAddr;
      this.city = city;
      this.state = state;
      this.zip = zip;
      this.location = location;
   }


   // Getter/Setter methods for attributes
   public int getAddrId () {
      return addrId;
   }

   public String getOwnerName () {
      return ownerName;
   }

   public int getHouseId () {
      return houseId;
   }

   public String getStreetAddr () {
      return streetAddr;
   }

   public String getCity () {
      return city;
   }

   public String getState () {
      return state;
   }

   public int getZip () {
      return zip;
   }

   public GeoLoc getLocation () {
      return location;
   }

   public void setAddrId (int addrId) {
      this.addrId = addrId;
   }

   public void setOwnerName (String ownerName) {
      this.ownerName = ownerName;
   }

   public void setHouseId (int houseId) {
      this.houseId = houseId;
   }

   public void setStreetAddr (String streetAddr) {
      this.streetAddr = streetAddr;
   }

   public void setCity (String city) {
      this.city = city;
   }

   public void setState (String state) {
      this.state = state;
   }

   public void setZip (int zip) {
      this.zip = zip;
   }

   public void setLocation (GeoLoc location) {
      this.location = location;
   }


   public String toString() {
      java.util.Hashtable h = new java.util.Hashtable();
      Class cls = getClass();
      Field[] fields = cls.getDeclaredFields();
      //AccessibleObject.setAccessible(fields, true);
      for(int i=0; i<fields.length; i++) {
         try {
            h.put(fields[i].getName(), fields[i].get(this) + "\n");
         }
         catch(IllegalAccessException e) {}
      }    
      if(cls.getSuperclass().getSuperclass() != null) {
         h.put("super", super.toString());
      }
      return cls.getName() + "\n" + h;
   }

}
